export declare class EmployeeLeaveType {
    /**
    * The Xero identifier for leave type
    */
    'leaveTypeID'?: string;
    /**
    * The schedule of accrual
    */
    'scheduleOfAccrual'?: EmployeeLeaveType.ScheduleOfAccrualEnum;
    /**
    * The number of hours accrued for the leave annually. This is 0 when the scheduleOfAccrual chosen is \"OnHourWorked\"
    */
    'hoursAccruedAnnually'?: number;
    /**
    * The maximum number of hours that can be accrued for the leave
    */
    'maximumToAccrue'?: number;
    /**
    * The initial number of hours assigned when the leave was added to the employee
    */
    'openingBalance'?: number;
    /**
    * The number of hours added to the leave balance for every hour worked by the employee. This is normally 0, unless the scheduleOfAccrual chosen is \"OnHourWorked\"
    */
    'rateAccruedHourly'?: number;
    /**
    * Specific for scheduleOfAccrual having percentage of gross earnings. Identifies how much percentage of gross earnings is accrued per pay period.
    */
    'percentageOfGrossEarnings'?: number;
    /**
    * Specific to Holiday pay. Flag determining if pay for leave type is added on each pay run.
    */
    'includeHolidayPayEveryPay'?: boolean;
    /**
    * Specific to Annual Leave. Flag to include leave available to take in advance in the balance in the payslip
    */
    'showAnnualLeaveInAdvance'?: boolean;
    /**
    * Specific to Annual Leave. Annual leave balance in dollars
    */
    'annualLeaveTotalAmountPaid'?: number;
    /**
    * The date when an employee becomes entitled to their accrual.
    */
    'scheduleOfAccrualDate'?: string;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export declare namespace EmployeeLeaveType {
    enum ScheduleOfAccrualEnum {
        AnnuallyAfter6Months,
        OnAnniversaryDate,
        PercentageOfGrossEarnings,
        NoAccruals
    }
}
